std::reverse_iterator::operator*,->(3)

NAME
std::reverse_iterator::operator*,-> - std::reverse_iterator::operator*,->

Synopsis
   reference operator*() const; (until C++17)
   constexpr reference operator*() const; (since C++17)
   pointer operator->() const; (until C++17)
   constexpr pointer operator->() const; (since C++17)
                        (1) (until C++20)
   constexpr pointer operator->() const (2)
   requires (std::is_pointer_v<Iter> || (since C++20)
   requires (const Iter i) { i.operator->(); });
   Returns a reference or pointer to the element previous to current.
   1) Equivalent to Iter tmp = current; return *--tmp;
   2) Equivalent to return std::addressof(operator*());. (until C++20)
   2) Equivalent to return current - 1; if Iter is a pointer type. (since C++20)
   Otherwise, equivalent to return std::prev(current).operator->();.

Parameters
   (none)

Return value
   Reference or pointer to the element previous to current.

Example
// Run this code
 #include <complex>
 #include <iostream>
 #include <iterator>
 #include <vector>
 int main()
 {
     using RI0 = std::reverse_iterator<int*>;
     int a[] { 0, 1, 2, 3 };
     RI0 r0 { std::rbegin(a) };
     std::cout << "*r0 = " << *r0 << '\n';
     *r0 = 42;
     std::cout << "a[3] = " << a[3] << '\n';
     using RI1 = std::reverse_iterator<std::vector<int>::iterator>;
     std::vector<int> vi { 0, 1, 2, 3 };
     RI1 r1 { vi.rend() - 2 };
     std::cout << "*r1 = " << *r1 << '\n';
     using RI2 = std::reverse_iterator<std::vector<std::complex<double>>::iterator>;
     std::vector<std::complex<double>> vc { {1,2}, {3,4}, {5,6}, {7,8} };
     RI2 r2 { vc.rbegin() + 1 };
     std::cout << "vc[2] = " << "(" << r2->real() << "," << r2->imag() << ")\n";
 }

Output:
 *r0 = 3
 a[3] = 42
 *r1 = 1
 vc[2] = (5,6)

See also
   operator[] accesses an element by index
              (public member function)